﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfApplication2
{
    //1
    abstract class Meeting
    {
        DateTime when;
        TimeSpan duration;
        protected string title;

        static int totalNumber;
        static TimeSpan totalDuration;

        public override string ToString()
        {
            return "Meeting " + title + " " + when + " " + duration;
        }

        public Meeting()
        {
            when = DateTime.Now;
            duration = TimeSpan.FromHours(2.0);
            title = "Unbenannt";
            totalNumber++;
            totalDuration += duration;
        }

        public Meeting(double hours)
        {
            when = DateTime.Now;
            duration = TimeSpan.FromHours(hours);
            title = "Unbenannt";
            totalNumber++;
            totalDuration += duration;
        }

        public Meeting(DateTime when, TimeSpan duration, string title)
        {
            this.when = when;
            this.duration = duration;
            this.title = title;
            totalNumber++;
            totalDuration += duration;
        }

        public bool IsNow()
        {
            DateTime now = DateTime.Now;
            return when <= now && now <= when + duration;
        }

        public void Postpone(double hours)
        {
            when += TimeSpan.FromHours(hours);
        }

        public void Postpone(TimeSpan ts)
        {
            when += ts;
        }

        public TimeSpan Duration
        {
            get
            {
                return duration;
            }
            set
            {
                duration = value;
            }
        }

        public DateTime When
        {
            get
            {
                return when;
            }
            set
            {
                when = value;
            }
        }

        static public int TotalNumber
        {
            get { return totalNumber; }
        }

        static public TimeSpan TotalDuration
        {
            get { return totalDuration; }
        }

        static public double GetAverageDuration()
        {
            return TotalDuration.TotalHours / TotalNumber;
        }

        // 1
        public abstract void Remind();

        public virtual int Priority
        {
            get
            {
                return 0;
            }
        }
    }

    class BusinessMeeting : Meeting, ICloneable, IComparable
    {
        decimal budget;
        string topic;

        public BusinessMeeting(DateTime when, TimeSpan duration, string title, decimal budget, string topic)
        : base(when, duration, title)
        {
            this.budget = budget;
            this.topic = topic;
        }

        public void DoubleBudget()
        {
            budget *= 2;
            TimeSpan a = Duration;
            string b = title;
        }

        public override void Remind()
        {
            DateTime now = DateTime.Now;
            if (now + TimeSpan.FromHours(5) >= When
                && now <= When + Duration)
            {
                System.Media.SystemSounds.Exclamation.Play();
            }
        }

        public override int Priority
        {
            get
            {
                return 10;
            }
        }

        public override string ToString()
        {
            return "Business Meeting";
        }

        public object Clone()
        {
            throw new NotImplementedException();
        }

        public int CompareTo(object obj)
        {
            throw new NotImplementedException();
        }
    }

    class Grandchild : BusinessMeeting
    {
        public Grandchild()
            : base(DateTime.Now, TimeSpan.FromHours(2.0), "jzgujzg", 24323, "iuhiuiluh")
        {
        }

        public override void Remind()
        {
            DateTime w = When;
            string u = title;
        }
    }

    class Dinner : Meeting
    {
        public enum Style { Italian, Turkish, Chinese };
        Style style;

        public override string ToString()
        {
            return "Dinner";
        }

        public override void Remind()
        {
            DateTime now = DateTime.Now;
            if (now + TimeSpan.FromHours(10) >= When
                && now <= When + Duration)
            {
                System.Windows.MessageBox.Show(title + " nicht vergessen!");
            }
        }
    }
}
